/*! \file   memcpy.c
    \brief  memcpy function
    \author Markus L. Noga <noga@inrialpes.fr>
*/
    
/*
 *  The contents of this file are subject to the Mozilla Public License
 *  Version 1.0 (the "License"); you may not use this file except in
 *  compliance with the License. You may obtain a copy of the License at
 *  http://www.mozilla.org/MPL/
 *
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *
 *  The Original Code is legOS code, released March 19, 1999.
 *
 *  The Initial Developer of the Original Code is Markus L. Noga.
 *  Portions created by Markus L. Noga are Copyright (C) 1999
 *  Markus L. Noga. All Rights Reserved.
 *
 *  Contributor(s): Markus L. Noga <noga@inrialpes.fr>
 */

typedef unsigned	size_t;			// data type for memory sizes


///////////////////////////////////////////////////////////////////////////////
//
// Functions
//
///////////////////////////////////////////////////////////////////////////////

//!  copy memory block from src to dest.
/*! \param dest destination
    \param src  source
    \param size number of bytes to copy
    
    \warning behaviour is undefined in case source and destination blocks 
             overlap.
*/
void memcpy(void* dest,void* src,size_t size) {
	register void* _src  __asm__ ("r0")=src;
	register size_t _end  __asm__ ("r1")=size;
	register void* _dest __asm__ ("r2")=dest;
__asm__ __volatile__(
	"add.w r0,r1\n"
	"jsr @0x042a:0"
	: 					// output
	:					// input
	: "r0","r1","r2","r3","cc","memory"	// clobbered (final)
	);					
}
